<?php
//面板设置页面
function pcloud_setting_control() {
    $error = new WP_Error;

    $page = admin_url('admin.php?page=pcloud-setting');
    $schedule = wp_get_schedule('pcloud');

    if(isset($_POST['action']) && 'setting' == $_POST['action']) {
        $path = sanitize_text_field($_POST['path']);
        if($path) {
            $path = '/' . trim($path, '/');
            update_option('pcloud_path', $path);
        } else {
            delete_option('pcloud_path');
        }

        $username = sanitize_text_field($_POST['username']);
        if($username) {
            $username = strtolower($username);
            update_option('pcloud_username', $username);
        } else {
            delete_option('pcloud_username');
            delete_option('pcloud_password');
        }

        $password = sanitize_text_field($_POST['password']);
        if($password && $username) {
            $password = pcloud_encrypt($password);
            update_option('pcloud_password', $password);
        }

        $cycle = $_POST['cycle'];
        if($schedule != $cycle) {
            pcloud_delete_cron();
            if($cycle != 'off') {
                wp_schedule_event(strtotime(date('Y-m-d')), $cycle, 'pcloud');
            }
            $schedule = $cycle;
        }

        $error->add('info', '设置保存成功！');
    }
?>

<link rel="stylesheet" href="<?php echo plugins_url('pcloud/css/control.css'); ?>">

<div class="mywrap wp-clearfix">
    <?php
        if($error->has_errors()) {
            if($error->get_error_message('error')) {
                echo '<div class="notice is-dismissible error">' . $error->get_error_message('error') . '</div>';
            } else {
                echo '<div class="notice is-dismissible success">' . $error->get_error_message('info') . '</div>';
            }
        }
    ?>

    <form class="entry" method="post" action="<?php echo $page; ?>">
        <table class="form-table">
            <tbody>
                <tr>
                    <th scope="row"><label for="cycle">定时</label></th>
                    <td>
                        <select name="cycle" id="cycle">
                            <option value="daily"<?php if('daily' == $schedule) echo ' selected'; ?>>每天</option>
                            <option value="weekly"<?php if('weekly' == $schedule) echo ' selected'; ?>>每周</option>
                            <option value="monthly"<?php if('monthly' == $schedule) echo ' selected'; ?>>每月</option>
                            <option value="off"<?php if(!$schedule || 'off' == $schedule) echo ' selected'; ?>>关闭定时</option>
                        </select>
                        <p class="description">定时备份仅针对数据库，附件是实时同步到<a href="https://u.pcloud.com/#page=register&invite=Vcg87ZgTQamV" target="_blank" rel="noopener nofollow">pCloud网盘</a>的。</p>
                    </td>
                </tr>
                <tr>
                    <th scope="row">
                        <label for="path">路径</label>
                    </th>
                    <td>
                        <input id="path" name="path" class="regular-text code" type="text" value="<?php echo get_option('pcloud_path'); ?>">
                        <p class="description">指定备份目录，默认备份到<a href="https://u.pcloud.com/#page=register&invite=Vcg87ZgTQamV" target="_blank" rel="noopener nofollow">pCloud网盘</a>根目录。</p>
                    </td>
                </tr>
                <tr>
                    <th scope="row">
                        <label for="username">账号</label>
                    </th>
                    <td>
                        <input id="username" name="username" class="regular-text code" type="text" value="<?php echo get_option('pcloud_username'); ?>" required autocomplete="new-password">
                        <p class="description">访问<a href="https://u.pcloud.com/#page=register&invite=Vcg87ZgTQamV" target="_blank" rel="noopener nofollow">pCloud官网</a>注册。</p>
                    </td>
                </tr>
                <tr>
                    <th scope="row">
                        <label for="password">密码</label>
                    </th>
                    <td>
                        <input id="password" name="password" class="regular-text code" type="password" value="" placeholder="******" autocomplete="new-password">
                        <p class="description">加密保存到数据库，不用担心安全问题。</p>
                    </td>
                </tr>
            </tbody>
        </table>
        <p>
            <input class="button-primary" type="submit" value="保存设置">
            <input type="hidden" name="action" value="setting">
        </p>
    </form>
</div>

<?php } ?>